commit 3fd1c1a8640bf84c32695531a3ed81d4338409aa
Author: Richard Biener <rguenther@suse.de>
Date:   Mon Jan 9 12:46:28 2023 +0100

    middle-end/69482 - not preserving volatile accesses
    
    The following addresses a long standing issue with not preserving
    accesses to non-volatile objects through volatile qualified
    pointers in the case that object gets expanded to a register.  The
    fix is to treat accesses to an object with a volatile qualified
    access as forcing that object to memory.  This issue got more
    exposed recently so it regressed more since GCC 11.
    
            PR middle-end/69482
            * cfgexpand.cc (discover_nonconstant_array_refs_r): Volatile
            qualified accesses also force objects to memory.
    
            * gcc.target/i386/pr69482-1.c: New testcase.
            * gcc.target/i386/pr69482-2.c: Likewise.
    
    (cherry picked from commit a5a8242153d078f1ebe60f00409415da260a29ee)

diff --git a/gcc/cfgexpand.cc b/gcc/cfgexpand.cc
index eadec9a2bfd..006f46fa9db 100644
--- a/gcc/cfgexpand.cc
+++ b/gcc/cfgexpand.cc
@@ -6311,6 +6311,15 @@ discover_nonconstant_array_refs_r (tree * tp, int *walk_subtrees,
 
   if (IS_TYPE_OR_DECL_P (t))
     *walk_subtrees = 0;
+  else if (REFERENCE_CLASS_P (t) && TREE_THIS_VOLATILE (t))
+    {
+      t = get_base_address (t);
+      if (t && DECL_P (t)
+	  && DECL_MODE (t) != BLKmode
+	  && !TREE_ADDRESSABLE (t))
+	bitmap_set_bit (forced_stack_vars, DECL_UID (t));
+      *walk_subtrees = 0;
+    }
   else if (TREE_CODE (t) == ARRAY_REF || TREE_CODE (t) == ARRAY_RANGE_REF)
     {
       while (((TREE_CODE (t) == ARRAY_REF || TREE_CODE (t) == ARRAY_RANGE_REF)
diff --git a/gcc/testsuite/gcc.target/i386/pr69482-1.c b/gcc/testsuite/gcc.target/i386/pr69482-1.c
new file mode 100644
index 00000000000..7ef0e71b17c
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr69482-1.c
@@ -0,0 +1,16 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -fno-stack-protector -fomit-frame-pointer" } */
+
+static inline void memset_s(void* s, int n) {
+  volatile unsigned char * p = s;
+  for(int i = 0; i < n; ++i) {
+    p[i] = 0;
+  }
+}
+
+void test() {
+  unsigned char x[4];
+  memset_s(x, sizeof x);
+}
+
+/* { dg-final { scan-assembler-times "mov" 4 } } */
diff --git a/gcc/testsuite/gcc.target/i386/pr69482-2.c b/gcc/testsuite/gcc.target/i386/pr69482-2.c
new file mode 100644
index 00000000000..6aabe4fb393
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr69482-2.c
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fomit-frame-pointer" } */
+
+void bar ()
+{
+  int j;
+  *(volatile int *)&j = 0;
+}
+
+/* { dg-final { scan-assembler-times "mov" 1 } } */

